This is the README accompanying the source code to Simon Tatham's
puzzle collection. The collection's web site is at
<https://www.chiark.greenend.org.uk/~sgtatham/puzzles/>.

If you've obtained the source code by downloading a .tar.gz archive
from the Puzzles web site, you should find several Makefiles in the
source code. However, if you've checked the source code out from the
Puzzles git repository, you won't find the Makefiles: they're
automatically generated by `mkfiles.pl', so run that to create them.

The Makefiles include:

 - `Makefile.am', together with the static `configure.ac', is intended
   as input to automake. Run `mkauto.sh' to turn these into a
   configure script and Makefile.in, after which you can then run
   `./configure' to create an actual Unix Makefile.

 - `Makefile.vc' should work under MS Visual C++ on Windows. Run
   'nmake /f Makefile.vc' in a Visual Studio command prompt.

 - `Makefile.cyg' should work under Cygwin / MinGW. With appropriate
   tweaks and setting of TOOLPATH, it should work for both compiling
   on Windows and cross-compiling on Unix.

 - `Makefile.osx' should work under Mac OS X, provided the Xcode
   tools are installed. It builds a single monolithic OS X
   application capable of running any of the puzzles, or even more
   than one of them at a time.

 - `Makefile.wce' should work under MS eMbedded Visual C++ on
   Windows and the Pocket PC SDK; it builds Pocket PC binaries.

Many of these Makefiles build a program called `nullgame' in
addition to the actual game binaries. This program doesn't do
anything; it's just a template for people to start from when adding
a new game to the collection, and it's compiled every time to ensure
that it _does_ compile and link successfully (because otherwise it
wouldn't be much use as a template). Once it's built, you can run it
if you really want to (but it's very boring), and then you should
ignore it.

DO NOT EDIT THE MAKEFILES DIRECTLY, if you plan to send any changes
back to the maintainer. The makefiles are generated automatically by
the Perl script `mkfiles.pl' from the file `Recipe' and the various
.R files. If you need to change the makefiles as part of a patch,
you should change Recipe, *.R, and/or mkfiles.pl.

The manual is provided in Windows Help format for the Windows build;
in text format for anyone who needs it; and in HTML for the Mac OS X
application and for the web site. It is generated from a Halibut
source file (puzzles.but), which is the preferred form for
modification. To generate the manual in other formats, rebuild it,
or learn about Halibut, visit the Halibut website at
<https://www.chiark.greenend.org.uk/~sgtatham/halibut/>.

# -*- makefile -*-

GROUP_EXTRA        = LATIN
GROUP_EXTRA_SOLVER = LATIN_SOLVER

group    : [X] GTK COMMON group GROUP_EXTRA group-icon|no-icon

group    : [G] WINDOWS COMMON group GROUP_EXTRA group.res|noicon.res

groupsolver : [U] group[STANDALONE_SOLVER] GROUP_EXTRA_SOLVER STANDALONE
groupsolver : [C] group[STANDALONE_SOLVER] GROUP_EXTRA_SOLVER STANDALONE

ALL += group[COMBINED] GROUP_EXTRA

!begin am gtk
GAMES += group
!end

!begin >list.c
    A(group) \
!end

!begin >gamedesc.txt
group:group.exe:Group:Group theory puzzle:Complete the unfinished Cayley table of a group.
!end

# -*- makefile -*-

LOOPY_EXTRA = tree234 dsf grid penrose loopgen

loopy     : [X] GTK COMMON loopy LOOPY_EXTRA loopy-icon|no-icon

loopy     : [G] WINDOWS COMMON loopy LOOPY_EXTRA loopy.res|noicon.res

loopysolver :   [U] loopy[STANDALONE_SOLVER] LOOPY_EXTRA STANDALONE m.lib
loopysolver :   [C] loopy[STANDALONE_SOLVER] LOOPY_EXTRA STANDALONE

#penrose :    [U] penrose[TEST_PENROSE] STANDALONE m.lib
#penrose :    [C] penrose[TEST_PENROSE] STANDALONE

#test-basis : [U] penrose[TEST_VECTORS] tree234 STANDALONE m.lib
#test-basis : [C] penrose[TEST_VECTORS] tree234 STANDALONE


ALL += loopy[COMBINED] LOOPY_EXTRA

!begin am gtk
GAMES += loopy
!end

!begin >list.c
    A(loopy) \
!end

!begin >gamedesc.txt
loopy:loopy.exe:Loopy:Loop-drawing puzzle:Draw a single closed loop, given clues about number of adjacent edges.
!end

# -*- makefile -*-

cube     : [X] GTK COMMON cube cube-icon|no-icon

cube     : [G] WINDOWS COMMON cube cube.res|noicon.res

ALL += cube[COMBINED]

!begin am gtk
GAMES += cube
!end

!begin >list.c
    A(cube) \
!end

!begin >gamedesc.txt
cube:cube.exe:Cube:Rolling cube puzzle:Pick up all the blue squares by rolling the cube over them.
!end

# -*- makefile -*-

BRIDGES_EXTRA = dsf findloop

bridges  : [X] GTK COMMON bridges BRIDGES_EXTRA bridges-icon|no-icon

bridges  : [G] WINDOWS COMMON bridges BRIDGES_EXTRA bridges.res|noicon.res

ALL += bridges[COMBINED] BRIDGES_EXTRA

!begin am gtk
GAMES += bridges
!end

!begin >list.c
    A(bridges) \
!end

!begin >gamedesc.txt
bridges:bridges.exe:Bridges:Bridge-placing puzzle:Connect all the islands with a network of bridges.
!end

# -*- makefile -*-

GALAXIES_EXTRA = dsf

galaxies : [X] GTK COMMON galaxies GALAXIES_EXTRA galaxies-icon|no-icon

galaxies : [G] WINDOWS COMMON galaxies GALAXIES_EXTRA galaxies.res|noicon.res

galaxiessolver : [U] galaxies[STANDALONE_SOLVER] GALAXIES_EXTRA STANDALONE m.lib
galaxiessolver : [C] galaxies[STANDALONE_SOLVER] GALAXIES_EXTRA STANDALONE

galaxiespicture : [U] galaxies[STANDALONE_PICTURE_GENERATOR] GALAXIES_EXTRA STANDALONE
                + m.lib
galaxiespicture : [C] galaxies[STANDALONE_PICTURE_GENERATOR] GALAXIES_EXTRA STANDALONE

ALL += galaxies[COMBINED] GALAXIES_EXTRA

!begin am gtk
GAMES += galaxies
!end

!begin >list.c
    A(galaxies) \
!end

!begin >gamedesc.txt
galaxies:galaxies.exe:Galaxies:Symmetric polyomino puzzle:Divide the grid into rotationally symmetric regions each centred on a dot.
!end

# -*- makefile -*-

TRACKS_EXTRA = dsf findloop

tracks  : [X] GTK COMMON tracks TRACKS_EXTRA tracks-icon|no-icon

tracks  : [G] WINDOWS COMMON tracks TRACKS_EXTRA tracks.res|noicon.res

ALL += tracks[COMBINED] TRACKS_EXTRA

!begin am gtk
GAMES += tracks
!end

!begin >list.c
    A(tracks) \
!end

!begin >gamedesc.txt
tracks:tracks.exe:Tracks:Path-finding railway track puzzle:Fill in the railway track according to the clues.
!end

# -*- makefile -*-

MINES_EXTRA = tree234

mines    : [X] GTK COMMON mines MINES_EXTRA mines-icon|no-icon

mines    : [G] WINDOWS COMMON mines MINES_EXTRA mines.res|noicon.res

mineobfusc :    [U] mines[STANDALONE_OBFUSCATOR] MINES_EXTRA STANDALONE
mineobfusc :    [C] mines[STANDALONE_OBFUSCATOR] MINES_EXTRA STANDALONE

ALL += mines[COMBINED] MINES_EXTRA

!begin am gtk
GAMES += mines
!end

!begin >list.c
    A(mines) \
!end

!begin >gamedesc.txt
mines:mines.exe:Mines:Mine-finding puzzle:Find all the mines without treading on any of them.
!end

# -*- makefile -*-

samegame : [X] GTK COMMON samegame samegame-icon|no-icon

samegame : [G] WINDOWS COMMON samegame samegame.res|noicon.res

ALL += samegame[COMBINED]

!begin am gtk
GAMES += samegame
!end

!begin >list.c
    A(samegame) \
!end

!begin >gamedesc.txt
samegame:samegame.exe:Same Game:Block-clearing puzzle:Clear the grid by removing touching groups of the same colour squares.
!end

# -*- makefile -*-

sixteen  : [X] GTK COMMON sixteen sixteen-icon|no-icon

sixteen  : [G] WINDOWS COMMON sixteen sixteen.res|noicon.res

ALL += sixteen[COMBINED]

!begin am gtk
GAMES += sixteen
!end

!begin >list.c
    A(sixteen) \
!end

!begin >gamedesc.txt
sixteen:sixteen.exe:Sixteen:Toroidal sliding block puzzle:Slide a row at a time to arrange the tiles into order.
!end

# -*- makefile -*-

TENTS_EXTRA = matching dsf

tents    : [X] GTK COMMON tents TENTS_EXTRA tents-icon|no-icon

tents    : [G] WINDOWS COMMON tents TENTS_EXTRA tents.res|noicon.res

ALL += tents[COMBINED] TENTS_EXTRA

tentssolver :   [U] tents[STANDALONE_SOLVER] TENTS_EXTRA STANDALONE
tentssolver :   [C] tents[STANDALONE_SOLVER] TENTS_EXTRA STANDALONE

!begin am gtk
GAMES += tents
!end

!begin >list.c
    A(tents) \
!end

!begin >gamedesc.txt
tents:tents.exe:Tents:Tent-placing puzzle:Place a tent next to each tree.
!end

# -*- makefile -*-

FILLING_EXTRA = dsf

fillingsolver :	[U] filling[STANDALONE_SOLVER] FILLING_EXTRA STANDALONE
fillingsolver :	[C] filling[STANDALONE_SOLVER] FILLING_EXTRA STANDALONE

filling : [X] GTK COMMON filling FILLING_EXTRA filling-icon|no-icon

filling : [G] WINDOWS COMMON filling FILLING_EXTRA filling.res|noicon.res

ALL += filling[COMBINED] FILLING_EXTRA

!begin am gtk
GAMES += filling
!end

!begin >list.c
    A(filling) \
!end

!begin >gamedesc.txt
filling:filling.exe:Filling:Polyomino puzzle:Mark every square with the area of its containing region.
!end

# -*- makefile -*-

twiddle  : [X] GTK COMMON twiddle twiddle-icon|no-icon

twiddle  : [G] WINDOWS COMMON twiddle twiddle.res|noicon.res

ALL += twiddle[COMBINED]

!begin am gtk
GAMES += twiddle
!end

!begin >list.c
    A(twiddle) \
!end

!begin >gamedesc.txt
twiddle:twiddle.exe:Twiddle:Rotational sliding block puzzle:Rotate the tiles around themselves to arrange them into order.
!end

# -*- makefile -*-

DOMINOSA_EXTRA = laydomino dsf sort findloop

dominosa : [X] GTK COMMON dominosa DOMINOSA_EXTRA dominosa-icon|no-icon

dominosa : [G] WINDOWS COMMON dominosa DOMINOSA_EXTRA dominosa.res|noicon.res

ALL += dominosa[COMBINED] DOMINOSA_EXTRA

dominosasolver :   [U] dominosa[STANDALONE_SOLVER] DOMINOSA_EXTRA STANDALONE
dominosasolver :   [C] dominosa[STANDALONE_SOLVER] DOMINOSA_EXTRA STANDALONE

!begin am gtk
GAMES += dominosa
!end

!begin >list.c
    A(dominosa) \
!end

!begin >gamedesc.txt
dominosa:dominosa.exe:Dominosa:Domino tiling puzzle:Tile the rectangle with a full set of dominoes.
!end

# -*- makefile -*-

unruly : [X] GTK COMMON unruly unruly-icon|no-icon
unruly : [G] WINDOWS COMMON unruly unruly.res|noicon.res

unrulysolver : [U] unruly[STANDALONE_SOLVER] STANDALONE
unrulysolver : [C] unruly[STANDALONE_SOLVER] STANDALONE

ALL += unruly[COMBINED]

!begin am gtk
GAMES += unruly
!end

!begin >list.c
    A(unruly) \
!end

!begin >gamedesc.txt
unruly:unruly.exe:Unruly:Black and white grid puzzle:Fill in the black and white grid to avoid runs of three.
!end

# -*- makefile -*-

LIGHTUP_EXTRA = combi

lightup  : [X] GTK COMMON lightup LIGHTUP_EXTRA lightup-icon|no-icon

lightup  : [G] WINDOWS COMMON lightup LIGHTUP_EXTRA lightup.res|noicon.res

lightupsolver : [U] lightup[STANDALONE_SOLVER] LIGHTUP_EXTRA STANDALONE
lightupsolver : [C] lightup[STANDALONE_SOLVER] LIGHTUP_EXTRA STANDALONE

ALL += lightup[COMBINED] LIGHTUP_EXTRA

!begin am gtk
GAMES += lightup
!end

!begin >list.c
    A(lightup) \
!end

!begin >gamedesc.txt
lightup:lightup.exe:Light Up:Light-bulb placing puzzle:Place bulbs to light up all the squares.
!end

# -*- makefile -*-

SOLO_EXTRA = divvy dsf

solo     : [X] GTK COMMON solo SOLO_EXTRA solo-icon|no-icon

solo     : [G] WINDOWS COMMON solo SOLO_EXTRA solo.res|noicon.res

solosolver :    [U] solo[STANDALONE_SOLVER] SOLO_EXTRA STANDALONE
solosolver :    [C] solo[STANDALONE_SOLVER] SOLO_EXTRA STANDALONE

ALL += solo[COMBINED] SOLO_EXTRA

!begin am gtk
GAMES += solo
!end

!begin >list.c
    A(solo) \
!end

!begin >gamedesc.txt
solo:solo.exe:Solo:Number placement puzzle:Fill in the grid so that each row, column and square block contains one of every digit.
!end

# -*- makefile -*-

SIGNPOST_EXTRA = dsf

signpost : [X] GTK COMMON signpost SIGNPOST_EXTRA signpost-icon|no-icon
signpost : [G] WINDOWS COMMON signpost SIGNPOST_EXTRA signpost.res|noicon.res

signpostsolver : [U] signpost[STANDALONE_SOLVER] SIGNPOST_EXTRA STANDALONE m.lib
signpostsolver : [C] signpost[STANDALONE_SOLVER] SIGNPOST_EXTRA STANDALONE

ALL += signpost[COMBINED] SIGNPOST_EXTRA

!begin am gtk
GAMES += signpost
!end

!begin >list.c
    A(signpost) \
!end

!begin >gamedesc.txt
signpost:signpost.exe:Signpost:Square-connecting puzzle:Connect the squares into a path following the arrows.
!end

# -*- makefile -*-

rect     : [X] GTK COMMON rect rect-icon|no-icon

rect     : [G] WINDOWS COMMON rect rect.res|noicon.res

ALL += rect[COMBINED]

!begin am gtk
GAMES += rect
!end

!begin >list.c
    A(rect) \
!end

!begin >gamedesc.txt
rect:rect.exe:Rectangles:Rectangles puzzle:Divide the grid into rectangles with areas equal to the numbers.
!end

# -*- makefile -*-

MAGNETS_EXTRA = laydomino

magnets      : [X] GTK COMMON magnets MAGNETS_EXTRA magnets-icon|no-icon

magnets      : [G] WINDOWS COMMON magnets MAGNETS_EXTRA magnets.res|noicon.res

magnetssolver :     [U] magnets[STANDALONE_SOLVER] MAGNETS_EXTRA STANDALONE m.lib
magnetssolver :     [C] magnets[STANDALONE_SOLVER] MAGNETS_EXTRA STANDALONE

ALL += magnets[COMBINED] MAGNETS_EXTRA

!begin am gtk
GAMES += magnets
!end

!begin >list.c
    A(magnets) \
!end

!begin >gamedesc.txt
magnets:magnets.exe:Magnets:Magnet-placing puzzle:Place magnets to satisfy the clues and avoid like poles touching.
!end

# -*- makefile -*-

NET_EXTRA = tree234 dsf findloop

net      : [X] GTK COMMON net NET_EXTRA net-icon|no-icon

# The Windows Net shouldn't be called `net.exe' since Windows
# already has a reasonably important utility program by that name!
netgame  : [G] WINDOWS COMMON net NET_EXTRA net.res|noicon.res

ALL += net[COMBINED] NET_EXTRA

!begin am gtk
GAMES += net
!end

!begin >list.c
    A(net) \
!end

!begin >gamedesc.txt
net:netgame.exe:Net:Network jigsaw puzzle:Rotate each tile to reassemble the network.
!end

# -*- makefile -*-

PEARL_EXTRA    = dsf tree234 grid penrose loopgen tdq

pearl          : [X] GTK COMMON pearl PEARL_EXTRA pearl-icon|no-icon
pearl          : [G] WINDOWS COMMON pearl PEARL_EXTRA pearl.res?

pearlbench     : [U] pearl[STANDALONE_SOLVER] PEARL_EXTRA STANDALONE m.lib
pearlbench     : [C] pearl[STANDALONE_SOLVER] PEARL_EXTRA STANDALONE

ALL += pearl[COMBINED] PEARL_EXTRA

!begin am gtk
GAMES += pearl
!end

!begin >list.c
    A(pearl) \
!end

!begin >gamedesc.txt
pearl:pearl.exe:Pearl:Loop-drawing puzzle:Draw a single closed loop, given clues about corner and straight squares.
!end
